# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Drug(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Drug - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'proprietary_name': 'str',
            'non_proprietary_name': 'str',
            'drug_package_ids': 'list[str]'
        }

        self.attribute_map = {
            'id': 'id',
            'proprietary_name': 'proprietary_name',
            'non_proprietary_name': 'non_proprietary_name',
            'drug_package_ids': 'drug_package_ids'
        }

        self._id = None
        self._proprietary_name = None
        self._non_proprietary_name = None
        self._drug_package_ids = None

    @property
    def id(self):
        """
        Gets the id of this Drug.
        National Drug Code ID

        :return: The id of this Drug.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Drug.
        National Drug Code ID

        :param id: The id of this Drug.
        :type: str
        """
        self._id = id

    @property
    def proprietary_name(self):
        """
        Gets the proprietary_name of this Drug.
        Proprietary name of drug

        :return: The proprietary_name of this Drug.
        :rtype: str
        """
        return self._proprietary_name

    @proprietary_name.setter
    def proprietary_name(self, proprietary_name):
        """
        Sets the proprietary_name of this Drug.
        Proprietary name of drug

        :param proprietary_name: The proprietary_name of this Drug.
        :type: str
        """
        self._proprietary_name = proprietary_name

    @property
    def non_proprietary_name(self):
        """
        Gets the non_proprietary_name of this Drug.
        Non-proprietary name of drug

        :return: The non_proprietary_name of this Drug.
        :rtype: str
        """
        return self._non_proprietary_name

    @non_proprietary_name.setter
    def non_proprietary_name(self, non_proprietary_name):
        """
        Sets the non_proprietary_name of this Drug.
        Non-proprietary name of drug

        :param non_proprietary_name: The non_proprietary_name of this Drug.
        :type: str
        """
        self._non_proprietary_name = non_proprietary_name

    @property
    def drug_package_ids(self):
        """
        Gets the drug_package_ids of this Drug.
        Array of drug package Ids

        :return: The drug_package_ids of this Drug.
        :rtype: list[str]
        """
        return self._drug_package_ids

    @drug_package_ids.setter
    def drug_package_ids(self, drug_package_ids):
        """
        Sets the drug_package_ids of this Drug.
        Array of drug package Ids

        :param drug_package_ids: The drug_package_ids of this Drug.
        :type: list[str]
        """
        self._drug_package_ids = drug_package_ids

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

