# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ProvidersSearchResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ProvidersSearchResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'meta': 'Meta',
            'providers': 'list[Provider]',
            'states': 'list[State]'
        }

        self.attribute_map = {
            'meta': 'meta',
            'providers': 'providers',
            'states': 'states'
        }

        self._meta = None
        self._providers = None
        self._states = None

    @property
    def meta(self):
        """
        Gets the meta of this ProvidersSearchResponse.
        Metadata for query

        :return: The meta of this ProvidersSearchResponse.
        :rtype: Meta
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """
        Sets the meta of this ProvidersSearchResponse.
        Metadata for query

        :param meta: The meta of this ProvidersSearchResponse.
        :type: Meta
        """
        self._meta = meta

    @property
    def providers(self):
        """
        Gets the providers of this ProvidersSearchResponse.
        Providers that fit the requested criterion.

        :return: The providers of this ProvidersSearchResponse.
        :rtype: list[Provider]
        """
        return self._providers

    @providers.setter
    def providers(self, providers):
        """
        Sets the providers of this ProvidersSearchResponse.
        Providers that fit the requested criterion.

        :param providers: The providers of this ProvidersSearchResponse.
        :type: list[Provider]
        """
        self._providers = providers

    @property
    def states(self):
        """
        Gets the states of this ProvidersSearchResponse.
        States that fit the requested criterion.

        :return: The states of this ProvidersSearchResponse.
        :rtype: list[State]
        """
        return self._states

    @states.setter
    def states(self, states):
        """
        Sets the states of this ProvidersSearchResponse.
        States that fit the requested criterion.

        :param states: The states of this ProvidersSearchResponse.
        :type: list[State]
        """
        self._states = states

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

